searchData={"items":[{"type":"module","title":"LogsnagEx","doc":"LogSnag API Client for Elixir.","ref":"LogsnagEx.html"},{"type":"module","title":"Configuration - LogsnagEx","doc":"Add to your config/config.exs:\n\n    config :logsnag_ex,\n      default: [\n        token: \"your-token\",\n        project: \"your-project\",\n        disabled: false # optional\n      ]","ref":"LogsnagEx.html#module-configuration"},{"type":"module","title":"Usage - LogsnagEx","doc":"# Track an event\n    LogsnagEx.track(\"channel\", \"event\", description: \"Something happened\")\n\n    # Track with a different client\n    LogsnagEx.track(\"channel\", \"event\", client: MyApp.LogSnag)","ref":"LogsnagEx.html#module-usage"},{"type":"function","title":"LogsnagEx.group/3","doc":"Identifies a group in LogSnag.","ref":"LogsnagEx.html#group/3"},{"type":"function","title":"LogsnagEx.identify/2","doc":"Identifies a user in LogSnag.","ref":"LogsnagEx.html#identify/2"},{"type":"function","title":"LogsnagEx.track/3","doc":"Publishes a new log to LogSnag.","ref":"LogsnagEx.html#track/3"},{"type":"module","title":"LogsnagEx.Client","doc":"LogSnag client process that maintains the configuration and handles API requests.","ref":"LogsnagEx.Client.html"},{"type":"function","title":"LogsnagEx.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"LogsnagEx.Client.html#child_spec/1"},{"type":"function","title":"LogsnagEx.Client.get_config/1","doc":"","ref":"LogsnagEx.Client.html#get_config/1"},{"type":"function","title":"LogsnagEx.Client.start_link/1","doc":"","ref":"LogsnagEx.Client.html#start_link/1"},{"type":"behaviour","title":"LogsnagEx.ClientBehaviour","doc":"","ref":"LogsnagEx.ClientBehaviour.html"},{"type":"callback","title":"LogsnagEx.ClientBehaviour.request/4","doc":"","ref":"LogsnagEx.ClientBehaviour.html#c:request/4"},{"type":"module","title":"LogsnagEx.Insight","doc":"LogSnag Insight API Client.","ref":"LogsnagEx.Insight.html"},{"type":"module","title":"Usage - LogsnagEx.Insight","doc":"# Track an insight\n    LogsnagEx.Insight.track(\"Active Users\", 100, icon: \"👥\")\n\n    # Increment an insight\n    LogsnagEx.Insight.increment(\"Active Users\", 1)","ref":"LogsnagEx.Insight.html#module-usage"},{"type":"function","title":"LogsnagEx.Insight.increment/3","doc":"Increments an existing insight.","ref":"LogsnagEx.Insight.html#increment/3"},{"type":"function","title":"LogsnagEx.Insight.track/3","doc":"Publishes a new insight to LogSnag.","ref":"LogsnagEx.Insight.html#track/3"},{"type":"type","title":"LogsnagEx.Insight.value/0","doc":"","ref":"LogsnagEx.Insight.html#t:value/0"},{"type":"extras","title":"LogsnagEx","doc":"# LogsnagEx\n\n[![Hex.pm](https://img.shields.io/hexpm/v/logsnag_ex.svg)](https://hex.pm/packages/logsnag_ex)\n[![Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/logsnag_ex)\n\nAn Elixir client for [LogSnag](https://logsnag.com) - The event tracking platform for monitoring your products, services, and user behavior.","ref":"readme.html"},{"type":"extras","title":"Installation - LogsnagEx","doc":"Add `logsnag_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:logsnag_ex, \"~> 1.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - LogsnagEx","doc":"Configure LogSnag in your `config/config.exs` (or environment-specific config file):\n\n```elixir\nconfig :logsnag_ex,\n  default: [\n    token: System.get_env(\"LOGSNAG_TOKEN\"),\n    project: System.get_env(\"LOGSNAG_PROJECT\"),\n    disabled: Mix.env() != :prod # optional, defaults to false\n  ]\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Multiple Clients - LogsnagEx","doc":"You can configure multiple LogSnag clients for different purposes:\n\n```elixir\nconfig :logsnag_ex,\n  default: [\n    token: System.get_env(\"LOGSNAG_TOKEN\"),\n    project: System.get_env(\"LOGSNAG_PROJECT\")\n  ],\n  analytics: [\n    token: System.get_env(\"LOGSNAG_TOKEN\"),\n    project: System.get_env(\"LOGSNAG_PROJECT_2\"),\n    name: MyApp.AnalyticsLogSnag\n  ]\n```\n\nThen in your application supervision tree:\n\n```elixir\nchildren = [\n  {LogsnagEx.Client, Application.get_env(:logsnag_ex, :default, [])},\n  {LogsnagEx.Client, Application.get_env(:logsnag_ex, :analytics, [])}\n]\n```","ref":"readme.html#multiple-clients"},{"type":"extras","title":"Setup - LogsnagEx","doc":"The library is an OTP application, so it will automatically start its supervision tree. You don't need to add anything to your supervision tree unless you're using multiple clients.","ref":"readme.html#setup"},{"type":"extras","title":"Single Client (Default) - LogsnagEx","doc":"Just add the configuration to your `config/config.exs`:\n\n```elixir\nconfig :logsnag_ex,\n  default: [\n    token: System.get_env(\"LOGSNAG_TOKEN\"),\n    project: System.get_env(\"LOGSNAG_PROJECT\")\n  ]\n```","ref":"readme.html#single-client-default"},{"type":"extras","title":"Multiple Clients - LogsnagEx","doc":"For multiple clients, configure them in your config:\n\n```elixir\nconfig :logsnag_ex,\n  default: [\n    token: System.get_env(\"LOGSNAG_TOKEN\"),\n    project: System.get_env(\"LOGSNAG_PROJECT\")\n  ],\n  analytics: [\n    token: System.get_env(\"LOGSNAG_TOKEN\"),\n    project: System.get_env(\"LOGSNAG_PROJECT_2\"),\n    client: MyApp.AnalyticsLogSnag\n  ]\n```\n\nThen add the additional clients to your supervision tree:\n\n```elixir\n# lib/your_app/application.ex\ndef start(_type, _args) do\n  children = [\n    # ... your other children ...\n    {LogsnagEx.Client, Application.get_env(:logsnag_ex, :analytics, [])}\n  ]\n\n  opts = [strategy: :one_for_one, name: YourApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```","ref":"readme.html#multiple-clients"},{"type":"extras","title":"Usage - LogsnagEx","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Tracking Events - LogsnagEx","doc":"```elixir\n# Simple event\nLogsnagEx.track(\"user-signup\", \"New User Registered\")\n\n# Event with all options\nLogsnagEx.track(\"payments\", \"Payment Received\",\n  description: \"User completed payment for premium plan\",\n  icon: \"💰\",\n  tags: %{\n    order_id: \"12345\",\n    amount: \"$99.99\"\n  },\n  notify: true,\n  user_id: \"user-123\",  # Optional user association\n  parser: \"markdown\",   # Optional: \"markdown\" or \"text\"\n  date: DateTime.utc_now()  # Optional timestamp\n)\n```","ref":"readme.html#tracking-events"},{"type":"extras","title":"Using Insights - LogsnagEx","doc":"Insights help you track metrics and KPIs:\n\n```elixir\n# Track a metric\nLogsnagEx.Insight.track(\"Active Users\", 100, icon: \"👥\")\n\n# Increment a metric\nLogsnagEx.Insight.increment(\"Total Sales\", 99.99)\n\n# Using custom client\nLogsnagEx.Insight.track(\"Daily Revenue\", 10_000,\n  client: MyApp.AnalyticsLogSnag\n)\n```","ref":"readme.html#using-insights"},{"type":"extras","title":"User Identification - LogsnagEx","doc":"Track user properties:\n\n```elixir\nLogsnagEx.identify(\"user-123\",\n  %{\n    email: \"user@example.com\",\n    name: \"John Doe\",\n    plan: \"premium\"\n  }\n)\n```","ref":"readme.html#user-identification"},{"type":"extras","title":"Group Tracking - LogsnagEx","doc":"Track organization or group properties:\n\n```elixir\nLogsnagEx.group(\"user-123\", \"org-456\",\n  %{\n    name: \"Acme Corp\",\n    plan: \"enterprise\",\n    employees: 50\n  }\n)\n```","ref":"readme.html#group-tracking"},{"type":"extras","title":"Options - LogsnagEx","doc":"","ref":"readme.html#options"},{"type":"extras","title":"Event Tracking Options - LogsnagEx","doc":"- `:description` - Additional details about the event\n- `:icon` - Single emoji to represent the event\n- `:tags` - Map of key-value pairs for additional data\n- `:notify` - Boolean to enable push notifications\n- `:parser` - String \"markdown\" or \"text\" for description parsing\n- `:date` - DateTime for historical events\n- `:client` - Atom name of custom client to use","ref":"readme.html#event-tracking-options"},{"type":"extras","title":"Insight Options - LogsnagEx","doc":"- `:icon` - Single emoji to represent the insight\n- `:client` - Atom name of custom client to use","ref":"readme.html#insight-options"},{"type":"extras","title":"Development Environment - LogsnagEx","doc":"For development or testing, you can disable tracking:\n\n```elixir\nconfig :logsnag_ex,\n  default: [\n    token: \"test-token\",\n    project: \"test-project\",\n    disabled: true\n  ]\n```","ref":"readme.html#development-environment"},{"type":"extras","title":"Testing - LogsnagEx","doc":"The package uses Mox for testing. In your `test_helper.exs`:\n\n```elixir\nMox.defmock(LogsnagEx.MockClient, for: LogsnagEx.Client.Behaviour)\nApplication.put_env(:logsnag_ex, :client_module, LogsnagEx.MockClient)\n```\n\nExample test:\n\n```elixir\ntest \"track/3 sends a log event\" do\n  expect(LogsnagEx.MockClient, :request, fn :post, \"/log\", body, _name ->\n    assert body[\"channel\"] == \"test-channel\"\n    assert body[\"event\"] == \"test-event\"\n    {:ok, body}\n  end)\n\n  assert {:ok, response} = LogsnagEx.track(\"test-channel\", \"test-event\")\nend\n```","ref":"readme.html#testing"},{"type":"extras","title":"Error Handling - LogsnagEx","doc":"All functions return `{:ok, result}` or `{:error, error}`:\n\n```elixir\ncase LogsnagEx.track(\"channel\", \"event\") do\n  {:ok, response} ->\n    # Handle success\n  {:error, %LogsnagEx.Error{message: message, data: data}} ->\n    # Handle error\nend\n```","ref":"readme.html#error-handling"},{"type":"extras","title":"Contributing - LogsnagEx","doc":"1. Fork it\n2. Create your feature branch (`git checkout -b my-new-feature`)\n3. Commit your changes (`git commit -am 'Add some feature'`)\n4. Push to the branch (`git push origin my-new-feature`)\n5. Create new Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"License - LogsnagEx","doc":"MIT License. See LICENSE for details.","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}